

<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>gwmat.point_lens &mdash; GWMAT: Gravitational Wave Microlensing Analysis Tools 1.0.0 documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=7ab3649f" />

  
      <script src="../../_static/jquery.js?v=5d32c60e"></script>
      <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
      <script src="../../_static/documentation_options.js?v=8d563738"></script>
      <script src="../../_static/doctools.js?v=9a2dae69"></script>
      <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            GWMAT: Gravitational Wave Microlensing Analysis Tools
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../gwmat.html">gwmat package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">GWMAT: Gravitational Wave Microlensing Analysis Tools</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../gwmat.html">gwmat</a></li>
      <li class="breadcrumb-item active">gwmat.point_lens</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for gwmat.point_lens</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This module contains the `PointLens` class, which provides</span>
<span class="sd">functions to analyze microlensing effects caused by</span>
<span class="sd">an isolated point-mass lens.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Anuj Mishra &lt;anuj.mishra@ligo.org&gt;&quot;</span><span class="p">]</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">mpmath</span> <span class="kn">import</span> <span class="n">hyp1f1</span><span class="p">,</span> <span class="n">gamma</span>

<span class="kn">from</span> <span class="nn">.constants</span> <span class="kn">import</span> <span class="n">C_SI</span><span class="p">,</span> <span class="n">G_SI</span><span class="p">,</span> <span class="n">MSUN_SI</span>


<div class="viewcode-block" id="PointLens">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens">[docs]</a>
<span class="k">class</span> <span class="nc">PointLens</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    A class containing functions for studying microlensing</span>
<span class="sd">    due to an isolated point-mass lens.</span>
<span class="sd">    In such cases, two images are formed:</span>
<span class="sd">    one minima (type I) and one saddle (type II).</span>

<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1"># image positions</span>
<div class="viewcode-block" id="PointLens.x_minima">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.x_minima">[docs]</a>
    <span class="k">def</span> <span class="nf">x_minima</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the image position for</span>
<span class="sd">        the minima (type I) image.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float:</span>
<span class="sd">           Image position.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="p">(</span><span class="n">y</span> <span class="o">+</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">4</span><span class="p">))</span> <span class="o">/</span> <span class="mi">2</span></div>


<div class="viewcode-block" id="PointLens.x_saddle">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.x_saddle">[docs]</a>
    <span class="k">def</span> <span class="nf">x_saddle</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the image position for the</span>
<span class="sd">        saddle-point (type II) image.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           Image position.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="p">(</span><span class="n">y</span> <span class="o">-</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">4</span><span class="p">))</span> <span class="o">/</span> <span class="mi">2</span></div>


    <span class="c1"># image magnifications</span>
<div class="viewcode-block" id="PointLens.magification_minima">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.magification_minima">[docs]</a>
    <span class="k">def</span> <span class="nf">magification_minima</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the image magnification for</span>
<span class="sd">        the minima (type I) image.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           Image magnification.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="mi">1</span> <span class="o">/</span> <span class="mi">2</span> <span class="o">+</span> <span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">2</span><span class="p">)</span> <span class="o">/</span> <span class="p">(</span><span class="mi">2</span> <span class="o">*</span> <span class="n">y</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">4</span><span class="p">))</span></div>


<div class="viewcode-block" id="PointLens.magification_saddle">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.magification_saddle">[docs]</a>
    <span class="k">def</span> <span class="nf">magification_saddle</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the image magnification for</span>
<span class="sd">        the saddle-point (type II) image.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           Image magnification.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="mi">1</span> <span class="o">/</span> <span class="mi">2</span> <span class="o">-</span> <span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">2</span><span class="p">)</span> <span class="o">/</span> <span class="p">(</span><span class="mi">2</span> <span class="o">*</span> <span class="n">y</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">4</span><span class="p">))</span></div>


    <span class="c1"># time delay between the two micro-images</span>
<div class="viewcode-block" id="PointLens.time_delay_dimensionless">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.time_delay_dimensionless">[docs]</a>
    <span class="k">def</span> <span class="nf">time_delay_dimensionless</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the dimensionless time-delay</span>
<span class="sd">        between the two micro-images.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           dimensionless time-delay between micro-images.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="p">(</span><span class="n">y</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">4</span><span class="p">))</span> <span class="o">/</span> <span class="mf">2.0</span> <span class="o">+</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span>
            <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">4</span><span class="p">)</span> <span class="o">+</span> <span class="n">y</span><span class="p">)</span> <span class="o">/</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">4</span><span class="p">)</span> <span class="o">-</span> <span class="n">y</span><span class="p">)</span>
        <span class="p">)</span></div>


<div class="viewcode-block" id="PointLens.time_delay">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.time_delay">[docs]</a>
    <span class="k">def</span> <span class="nf">time_delay</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the time-delay between the two micro-images in seconds.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        ml : float</span>
<span class="sd">            Microlens mass.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>
<span class="sd">        zl : float, optional</span>
<span class="sd">            Lens-redshift. Default = 0</span>
<span class="sd">            (this is equivalent to absorbing the (1+zl) term into</span>
<span class="sd">            ml thereby making it as the redshifted lens mass).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float:</span>
<span class="sd">           time-delay between micro-images in seconds.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="p">(</span>
            <span class="mi">4</span> <span class="o">*</span> <span class="n">G_SI</span> <span class="o">*</span> <span class="n">MSUN_SI</span> <span class="o">*</span> <span class="n">ml</span> <span class="o">*</span> <span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">zl</span><span class="p">)</span> <span class="o">/</span> <span class="n">C_SI</span><span class="o">**</span><span class="mi">3</span>
        <span class="p">)</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_delay_dimensionless</span><span class="p">(</span><span class="n">y</span><span class="p">)</span></div>


    <span class="c1"># Geometric and Quasi Geometric approximations</span>
<div class="viewcode-block" id="PointLens.Fw_geometric_optics">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Fw_geometric_optics">[docs]</a>
    <span class="k">def</span> <span class="nf">Fw_geometric_optics</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the lensing amplification factor, F(w),</span>
<span class="sd">        assuming geometric optics approximation.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        w : float</span>
<span class="sd">           Dimensionless frequency.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex :</span>
<span class="sd">            Amplification factor F(w).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">magification_minima</span><span class="p">(</span><span class="n">y</span><span class="p">)))</span> <span class="o">-</span> <span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span>
            <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">magification_saddle</span><span class="p">(</span><span class="n">y</span><span class="p">))</span>
        <span class="p">)</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="n">w</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_delay_dimensionless</span><span class="p">(</span><span class="n">y</span><span class="p">))</span></div>


<div class="viewcode-block" id="PointLens.Fw_quasigeometric_optics">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Fw_quasigeometric_optics">[docs]</a>
    <span class="k">def</span> <span class="nf">Fw_quasigeometric_optics</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the lensing amplification factor, F(w),</span>
<span class="sd">        assuming Quasi-geometric optics approximation.</span>
<span class="sd">        References - arXiv:0402165</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        w : float</span>
<span class="sd">           Dimensionless frequency.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex :</span>
<span class="sd">           Amplification factor, F(w).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">Fw_geometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span>
            <span class="o">+</span> <span class="p">(</span><span class="mi">1</span><span class="n">j</span> <span class="o">/</span> <span class="p">(</span><span class="mi">3</span> <span class="o">*</span> <span class="n">w</span><span class="p">))</span>
            <span class="o">*</span> <span class="p">(</span>
                <span class="p">(</span><span class="mi">4</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_minima</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span>
                <span class="o">/</span> <span class="p">(</span><span class="nb">pow</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">x_minima</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span> <span class="o">+</span> <span class="mi">1</span><span class="p">),</span> <span class="mi">3</span><span class="p">)</span> <span class="o">*</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x_minima</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span> <span class="o">-</span> <span class="mi">1</span><span class="p">))</span>
            <span class="p">)</span>
            <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">magification_minima</span><span class="p">(</span><span class="n">y</span><span class="p">)))</span>
            <span class="o">+</span> <span class="p">(</span><span class="mi">1</span> <span class="o">/</span> <span class="p">(</span><span class="mi">3</span> <span class="o">*</span> <span class="n">w</span><span class="p">))</span>
            <span class="o">*</span> <span class="p">(</span>
                <span class="p">(</span><span class="mi">4</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_saddle</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span>
                <span class="o">/</span> <span class="p">(</span><span class="nb">pow</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">x_saddle</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span> <span class="o">+</span> <span class="mi">1</span><span class="p">),</span> <span class="mi">3</span><span class="p">)</span> <span class="o">*</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x_saddle</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span> <span class="o">-</span> <span class="mi">1</span><span class="p">))</span>
            <span class="p">)</span>
            <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">magification_saddle</span><span class="p">(</span><span class="n">y</span><span class="p">)))</span>
            <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="n">w</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_delay_dimensionless</span><span class="p">(</span><span class="n">y</span><span class="p">))</span>
        <span class="p">)</span></div>


    <span class="c1"># dimensionless frequency (w) in terms of dimensionful frequency (f), w(f)</span>
<div class="viewcode-block" id="PointLens.w_of_f">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.w_of_f">[docs]</a>
    <span class="k">def</span> <span class="nf">w_of_f</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Converts a dimensionful frequency (f)</span>
<span class="sd">        to the dimensionless frequency (w).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        f : float</span>
<span class="sd">           The dimensionful frequency which is to be converted.</span>
<span class="sd">        ml : float</span>
<span class="sd">            Microlens mass.</span>
<span class="sd">        zl : float, optional</span>
<span class="sd">            Lens-redshift. Default = 0</span>
<span class="sd">            (this is equivalent to absorbing the (1+zl) term into</span>
<span class="sd">            ml thereby making it as the redshifted lens mass).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           The dimensionless frequency, w(f).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">wf</span> <span class="o">=</span> <span class="n">f</span> <span class="o">*</span> <span class="p">(</span><span class="mf">8.0</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">pi</span> <span class="o">*</span> <span class="n">G_SI</span> <span class="o">*</span> <span class="n">MSUN_SI</span> <span class="o">/</span> <span class="n">C_SI</span><span class="o">**</span><span class="mi">3</span><span class="p">)</span> <span class="o">*</span> <span class="n">ml</span> <span class="o">*</span> <span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">zl</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">wf</span></div>


    <span class="c1"># dimensionful frequency (f) in terms of dimensionless frequency (w), f(w)</span>
<div class="viewcode-block" id="PointLens.f_of_w">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.f_of_w">[docs]</a>
    <span class="k">def</span> <span class="nf">f_of_w</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Converts a dimensionless frequency (w)</span>
<span class="sd">        to the dimensionful frequency (f).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        w : float</span>
<span class="sd">           The dimensionless frequency which is to be converted.</span>
<span class="sd">        ml : float</span>
<span class="sd">            Microlens mass.</span>
<span class="sd">        zl : float, optional</span>
<span class="sd">            Lens-redshift. Default = 0</span>
<span class="sd">            (this is equivalent to absorbing the (1+zl) term into</span>
<span class="sd">            ml thereby making it as the redshifted lens mass).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           The dimensionful frequency, f(w).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">fw</span> <span class="o">=</span> <span class="n">w</span> <span class="o">/</span> <span class="p">((</span><span class="mf">8.0</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">pi</span> <span class="o">*</span> <span class="n">G_SI</span> <span class="o">*</span> <span class="n">MSUN_SI</span> <span class="o">/</span> <span class="n">C_SI</span><span class="o">**</span><span class="mi">3</span><span class="p">)</span> <span class="o">*</span> <span class="n">ml</span> <span class="o">*</span> <span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">zl</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">fw</span></div>


    <span class="c1"># cutoff frequencies for transition to geometric optics</span>

<div class="viewcode-block" id="PointLens.w_cutoff_geometric_optics_tolerance_0p1">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.w_cutoff_geometric_optics_tolerance_0p1">[docs]</a>
    <span class="k">def</span> <span class="nf">w_cutoff_geometric_optics_tolerance_0p1</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">print_warning</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns a cutoff dimensionless frequency (wc) for a given</span>
<span class="sd">        y such that w &gt; wc gives relative error &lt; 0.1 %</span>
<span class="sd">        when geometric optics approximation is used.</span>
<span class="sd">        Valid for y in range (0.01, 5.00).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter, preferably in range (0.01, 5.00).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           The cutoff dimensionless frequency, wc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="n">y</span> <span class="o">&lt;=</span> <span class="mf">0.12</span><span class="p">:</span>
            <span class="n">wc</span> <span class="o">=</span> <span class="mf">15112.5</span> <span class="o">-</span> <span class="mf">52563.5</span> <span class="o">*</span> <span class="n">y</span>
        <span class="k">elif</span> <span class="mf">0.12</span> <span class="o">&lt;</span> <span class="n">y</span> <span class="o">&lt;=</span> <span class="mf">1.5</span><span class="p">:</span>
            <span class="n">wc</span> <span class="o">=</span> <span class="p">(</span>
                <span class="o">-</span><span class="mf">34.08</span>
                <span class="o">-</span> <span class="mf">12.84</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.0</span><span class="p">)</span>
                <span class="o">+</span> <span class="mf">114.33</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">2.0</span><span class="p">)</span>
                <span class="o">+</span> <span class="mf">0.89</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">3.0</span><span class="p">)</span>
            <span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">wc</span> <span class="o">=</span> <span class="o">-</span><span class="mf">15.02</span> <span class="o">+</span> <span class="mf">18.25</span> <span class="o">*</span> <span class="n">y</span> <span class="o">-</span> <span class="mf">2.66</span> <span class="o">*</span> <span class="n">y</span><span class="o">**</span><span class="mi">2</span>

        <span class="k">if</span> <span class="n">print_warning</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">y</span> <span class="o">&lt;</span> <span class="mf">0.01</span> <span class="ow">or</span> <span class="nb">round</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mf">5.00</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span>
                    <span class="sa">f</span><span class="s2">&quot;Warning: y = </span><span class="si">{</span><span class="n">y</span><span class="si">}</span><span class="s2"> is outside the interpolation</span><span class="se">\</span>
<span class="s2">                    range (0.01, 5.00). Thus, Extrapolating!&quot;</span>
                <span class="p">)</span>
        <span class="k">return</span> <span class="n">wc</span></div>


<div class="viewcode-block" id="PointLens.w_cutoff_geometric_optics_tolerance_1p0">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.w_cutoff_geometric_optics_tolerance_1p0">[docs]</a>
    <span class="k">def</span> <span class="nf">w_cutoff_geometric_optics_tolerance_1p0</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">print_warning</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns a cutoff dimensionless frequency (wc) for a given</span>
<span class="sd">        y such that w &gt; wc gives relative error &lt; 1.0 %</span>
<span class="sd">        when geometric optics approximation is used.</span>
<span class="sd">        Valid for y in range (0.01, 5.00).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter, preferably in range (0.01, 5.00).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           The cutoff dimensionless frequency, wc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="n">y</span> <span class="o">&lt;=</span> <span class="mf">0.071</span><span class="p">:</span>
            <span class="n">wc</span> <span class="o">=</span> <span class="mi">16604</span> <span class="o">-</span> <span class="mi">202686</span> <span class="o">*</span> <span class="n">y</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">wc</span> <span class="o">=</span> <span class="mf">0.64</span> <span class="o">+</span> <span class="mf">0.97</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.0</span><span class="p">)</span> <span class="o">+</span> <span class="mi">6</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">2.0</span><span class="p">)</span> <span class="o">+</span> <span class="mf">0.38</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">3.0</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">print_warning</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">y</span> <span class="o">&lt;</span> <span class="mf">0.01</span> <span class="ow">or</span> <span class="nb">round</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mf">5.00</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span>
                    <span class="sa">f</span><span class="s2">&quot;Warning: y = </span><span class="si">{</span><span class="n">y</span><span class="si">}</span><span class="s2"> is outside the interpolation</span><span class="se">\</span>
<span class="s2">                    range (0.01, 5.00). Thus, Extrapolating!&quot;</span>
                <span class="p">)</span>
        <span class="k">return</span> <span class="n">wc</span></div>


    <span class="c1"># cutoff frequencies for transition to Quasi-geometric optics</span>
<div class="viewcode-block" id="PointLens.w_cutoff_quasigeometric_optics_tolerance_0p1">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.w_cutoff_quasigeometric_optics_tolerance_0p1">[docs]</a>
    <span class="k">def</span> <span class="nf">w_cutoff_quasigeometric_optics_tolerance_0p1</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">print_warning</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns a cutoff dimensionless frequency (wc) for a given</span>
<span class="sd">        y such that w &gt; wc gives relative error &lt; 0.1 %</span>
<span class="sd">        when Quasi-geometric optics approximation is used.</span>
<span class="sd">        Valid for y in range (0.01, 5.00).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter, preferably in range (0.01, 5.00).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           The cutoff dimensionless frequency, wc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">wc</span> <span class="o">=</span> <span class="mi">9</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.0</span><span class="p">)</span> <span class="o">+</span> <span class="mf">0.04</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">2.0</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">print_warning</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">y</span> <span class="o">&lt;</span> <span class="mf">0.01</span> <span class="ow">or</span> <span class="nb">round</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mf">5.00</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span>
                    <span class="sa">f</span><span class="s2">&quot;Warning: y = </span><span class="si">{</span><span class="n">y</span><span class="si">}</span><span class="s2"> is outside the interpolation</span><span class="se">\</span>
<span class="s2">                    range (0.01, 5.00). Thus, Extrapolating!&quot;</span>
                <span class="p">)</span>
        <span class="k">return</span> <span class="n">wc</span></div>


<div class="viewcode-block" id="PointLens.w_cutoff_quasigeometric_optics_tolerance_1p0">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.w_cutoff_quasigeometric_optics_tolerance_1p0">[docs]</a>
    <span class="k">def</span> <span class="nf">w_cutoff_quasigeometric_optics_tolerance_1p0</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">print_warning</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns a cutoff dimensionless frequency (wc) for a given</span>
<span class="sd">        y such that w &gt; wc gives relative error &lt; 1.0 % when</span>
<span class="sd">        Quasi-geometric optics approximation is used.</span>
<span class="sd">        Valid for y in range (0.01, 5.00).</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter, preferably in range (0.01, 5.00).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        float :</span>
<span class="sd">           The cutoff dimensionless frequency, wc.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">wc</span> <span class="o">=</span> <span class="mi">4</span> <span class="o">*</span> <span class="nb">pow</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.0</span><span class="p">)</span> <span class="o">-</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">y</span><span class="p">)</span> <span class="o">/</span> <span class="mf">5.0</span>
        <span class="k">if</span> <span class="n">print_warning</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">y</span> <span class="o">&lt;</span> <span class="mf">0.01</span> <span class="ow">or</span> <span class="nb">round</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mf">5.00</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span>
                    <span class="sa">f</span><span class="s2">&quot;Warning: y = </span><span class="si">{</span><span class="n">y</span><span class="si">}</span><span class="s2"> is outside the interpolation</span><span class="se">\</span>
<span class="s2">                    range (0.01, 5.00). Thus, Extrapolating!&quot;</span>
                <span class="p">)</span>
        <span class="k">return</span> <span class="n">wc</span></div>


    <span class="c1"># Amplification factor related functions</span>
<div class="viewcode-block" id="PointLens.Fw_analytic">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Fw_analytic">[docs]</a>
    <span class="k">def</span> <span class="nf">Fw_analytic</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the amplification factor, F(w, y),</span>
<span class="sd">        for point lens using the analytical formula.</span>
<span class="sd">        It breaks down, or is difficult to compute,</span>
<span class="sd">        when the system approaches geometrical optics regime.</span>
<span class="sd">        In cases where it is not converging,</span>
<span class="sd">        use _Fw_effective()_.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        w : float</span>
<span class="sd">           The dimensionless frequency.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex:</span>
<span class="sd">           The Amplification Factor, F(w, y).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="n">w</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="k">return</span> <span class="mi">1</span>

        <span class="n">w</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">float128</span><span class="p">(</span><span class="n">w</span><span class="p">)</span>
        <span class="n">xm</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">float128</span><span class="p">((</span><span class="n">y</span> <span class="o">+</span> <span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">y</span> <span class="o">*</span> <span class="n">y</span> <span class="o">+</span> <span class="mf">4.0</span><span class="p">))</span> <span class="o">/</span> <span class="mf">2.0</span><span class="p">)</span>
        <span class="n">pm</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">float128</span><span class="p">(</span><span class="nb">pow</span><span class="p">(</span><span class="n">xm</span> <span class="o">-</span> <span class="n">y</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span> <span class="o">/</span> <span class="mf">2.0</span> <span class="o">-</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">xm</span><span class="p">))</span>
        <span class="n">hp</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">w</span> <span class="o">/</span> <span class="mf">2.0</span><span class="p">)</span> <span class="o">-</span> <span class="p">(</span><span class="mf">2.0</span> <span class="o">*</span> <span class="n">pm</span><span class="p">)</span>
        <span class="n">h</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">((</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span> <span class="o">*</span> <span class="n">w</span> <span class="o">/</span> <span class="mf">4.0</span><span class="p">)</span> <span class="o">+</span> <span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="p">(</span><span class="n">hp</span> <span class="o">*</span> <span class="n">w</span> <span class="o">/</span> <span class="mf">2.0</span><span class="p">))</span>
        <span class="n">gm</span> <span class="o">=</span> <span class="n">gamma</span><span class="p">(</span><span class="mf">1.0</span> <span class="o">-</span> <span class="p">(</span><span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="n">w</span> <span class="o">/</span> <span class="mf">2.0</span><span class="p">))</span>
        <span class="n">hf</span> <span class="o">=</span> <span class="n">hyp1f1</span><span class="p">((</span><span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="n">w</span> <span class="o">/</span> <span class="mf">2.0</span><span class="p">),</span> <span class="mf">1.0</span><span class="p">,</span> <span class="p">(</span><span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="n">y</span> <span class="o">*</span> <span class="n">y</span> <span class="o">*</span> <span class="n">w</span> <span class="o">/</span> <span class="mf">2.0</span><span class="p">))</span>
        <span class="n">Ff</span> <span class="o">=</span> <span class="n">h</span> <span class="o">*</span> <span class="n">gm</span> <span class="o">*</span> <span class="n">hf</span>
        <span class="k">return</span> <span class="nb">complex</span><span class="p">(</span><span class="n">Ff</span><span class="o">.</span><span class="n">real</span><span class="p">,</span> <span class="n">Ff</span><span class="o">.</span><span class="n">imag</span><span class="p">)</span></div>


<div class="viewcode-block" id="PointLens.Fw_effective">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Fw_effective">[docs]</a>
    <span class="k">def</span> <span class="nf">Fw_effective</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        An efficient computation of the point-lens amplification factor,</span>
<span class="sd">        F(w, y), that uses analytical expression along with</span>
<span class="sd">        the knowledge of the Quasi-geometric and the geometric optics limit.</span>
<span class="sd">        It can handle any value, but is efficient within regime of y in (0.01, 5).</span>

<span class="sd">        For dimensionful variant of this function, use: _point_Ff_eff()_.</span>

<span class="sd">        For mapping this function to an array of frequencies,</span>
<span class="sd">        use _Fw_effective_map()_</span>
<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        w : float</span>
<span class="sd">           The dimensionless frequency which is to be converted.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex :</span>
<span class="sd">           The Amplification Factor, F(w, y).</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">y</span> <span class="o">&lt;</span> <span class="mf">0.01</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_analytic</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span>

        <span class="n">wc_geo</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">w_cutoff_geometric_optics_tolerance_0p1</span><span class="p">(</span><span class="n">y</span><span class="p">)</span>
        <span class="n">wc_Qgeo</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">w_cutoff_quasigeometric_optics_tolerance_0p1</span><span class="p">(</span><span class="n">y</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">wc_Qgeo</span> <span class="o">&lt;</span> <span class="n">wc_geo</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">w</span> <span class="o">&lt;</span> <span class="n">wc_Qgeo</span><span class="p">:</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_analytic</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">wc_Qgeo</span> <span class="o">&lt;=</span> <span class="n">w</span> <span class="o">&lt;</span> <span class="n">wc_geo</span><span class="p">:</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_quasigeometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_geometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span>

        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_quasigeometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span></div>


<div class="viewcode-block" id="PointLens.Ff_effective">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Ff_effective">[docs]</a>
    <span class="k">def</span> <span class="nf">Ff_effective</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns an efficient computation of the point-lens amplification factor,</span>
<span class="sd">        F(f, ml, y, zl=0), that uses analytical expression along with</span>
<span class="sd">        the knowledge of the Quasi-geometric and the geometric optics limit.</span>
<span class="sd">        It can handle any value, but is efficient within regime of y in (0.01, 5).</span>

<span class="sd">        For dimensionless variant of this function,</span>
<span class="sd">        use: _Fw_effective()_.</span>

<span class="sd">        For mapping this function to an array of frequencies,</span>
<span class="sd">        use _point_Ff_eff_map()_.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        f : float</span>
<span class="sd">           Frequency (in Hz).</span>
<span class="sd">        ml : float</span>
<span class="sd">           Microlens mass.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>
<span class="sd">        zl : float, optional</span>
<span class="sd">            Lens-redshift. Default = 0</span>
<span class="sd">            (this is equivalent to absorbing the (1+zl) term into</span>
<span class="sd">            ml thereby making it as the redshifted lens mass).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex:</span>
<span class="sd">           The Amplification Factor, F(f, ml, y, zl).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">w</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">w_of_f</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">zl</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_effective</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span></div>


<div class="viewcode-block" id="PointLens.Fw_effective_map">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Fw_effective_map">[docs]</a>
    <span class="k">def</span> <span class="nf">Fw_effective_map</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ws</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Mapping fucntion for Fw_effective().</span>
<span class="sd">        This takes an array of (dimensionless) frequencies as input.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        ws : float array.</span>
<span class="sd">            Array of dimensionless frequencies.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex array :</span>
<span class="sd">           Array containing the amplification factors, F(ws, y).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">w</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_effective</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">),</span> <span class="n">ws</span><span class="p">)))</span></div>


<div class="viewcode-block" id="PointLens.Ff_effective_map">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Ff_effective_map">[docs]</a>
    <span class="k">def</span> <span class="nf">Ff_effective_map</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">fs</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Mapping fucntion for point_Ff_eff().</span>
<span class="sd">        This takes an array of frequencies as input.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        f : float array</span>
<span class="sd">           Array of Frequencies (in Hz).</span>
<span class="sd">        ml : float</span>
<span class="sd">            Microlens mass.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>
<span class="sd">        zl : float, optional</span>
<span class="sd">            Lens-redshift. Default = 0</span>
<span class="sd">            (this is equivalent to absorbing the (1+zl) term into</span>
<span class="sd">            ml thereby making ml as the redshifted lens mass).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex array :</span>
<span class="sd">            Array containing the amplification factors, F(fs, ml, y, zl).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">f</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">Ff_effective</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="p">),</span> <span class="n">fs</span><span class="p">)))</span></div>


<div class="viewcode-block" id="PointLens.Fw_analytic_map">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Fw_analytic_map">[docs]</a>
    <span class="k">def</span> <span class="nf">Fw_analytic_map</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ws</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Mapping fucntion for Fw_analytic().</span>
<span class="sd">        This takes an array of (dimensionless) frequencies as input.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        ws : float array</span>
<span class="sd">            Array of dimensionless frequencies.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex array :</span>
<span class="sd">           Array containing the amplification factors, F(ws, y).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">w</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_analytic</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">),</span> <span class="n">ws</span><span class="p">)))</span></div>


<div class="viewcode-block" id="PointLens.Ff_analytic">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Ff_analytic">[docs]</a>
    <span class="k">def</span> <span class="nf">Ff_analytic</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns amplification factor, F(f, ml, y, zl=0),</span>
<span class="sd">        for point lens using actual analytic formula.</span>
<span class="sd">        It breaks down, or is difficult to compute,</span>
<span class="sd">        when the system approaches geometrical optics regime.</span>

<span class="sd">        This function is dimensionful variant of Fw_analytic().</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        fs : float</span>
<span class="sd">            Frequency (in Hz).</span>
<span class="sd">        ml : float</span>
<span class="sd">            Microlens mass.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>
<span class="sd">        zl : float, optional</span>
<span class="sd">            Lens-redshift. Default = 0</span>
<span class="sd">            (this is equivalent to absorbing the (1+zl) term into</span>
<span class="sd">            ml thereby making it as the redshifted lens mass).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex :</span>
<span class="sd">           The Amplification Factor, F(f, ml, y, zl).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">w</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">w_of_f</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">zl</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_analytic</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span></div>


<div class="viewcode-block" id="PointLens.Ff_analytic_map">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Ff_analytic_map">[docs]</a>
    <span class="k">def</span> <span class="nf">Ff_analytic_map</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">fs</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Mapping fucntion for _Ff_analytic()_. This takes an array of frequencies as input.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        fs : float array</span>
<span class="sd">            Array of Frequencies (in Hz).</span>
<span class="sd">        ml : float</span>
<span class="sd">            Microlens mass.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>
<span class="sd">        zl : float, optional</span>
<span class="sd">            Lens-redshift. Default = 0</span>
<span class="sd">            (this is equivalent to absorbing the (1+zl) term into</span>
<span class="sd">            ml thereby making it as the redshifted lens mass).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex array :</span>
<span class="sd">           Array containing the amplification factors, F(fs, ml, y, zl).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">map</span><span class="p">(</span><span class="k">lambda</span> <span class="n">f</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">Ff_analytic</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="p">),</span> <span class="n">fs</span><span class="p">)))</span></div>


<div class="viewcode-block" id="PointLens.Ff_geometric_optics">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Ff_geometric_optics">[docs]</a>
    <span class="k">def</span> <span class="nf">Ff_geometric_optics</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the lensing amplification factor, F(f, ml, y, zl=0),</span>
<span class="sd">        assuming geometric optics approximation.</span>

<span class="sd">        This function is dimensionful variant of Fw_geometric_optics().</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        w : float</span>
<span class="sd">           Dimensionless frequency.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex :</span>
<span class="sd">            Amplification factor F(f, ml, y, zl).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">w</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">w_of_f</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">zl</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_geometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span></div>


<div class="viewcode-block" id="PointLens.Ff_quasigeometric_optics">
<a class="viewcode-back" href="../../gwmat.html#gwmat.point_lens.PointLens.Ff_quasigeometric_optics">[docs]</a>
    <span class="k">def</span> <span class="nf">Ff_quasigeometric_optics</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">zl</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Returns the lensing amplification factor, F(f, ml, y, zl=0),</span>
<span class="sd">        assuming Quasi-geometric optics approximation.</span>

<span class="sd">        This function is dimensionful variant of Ff_quasigeometric_optics().</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        w : float</span>
<span class="sd">           Dimensionless frequency.</span>
<span class="sd">        y : float</span>
<span class="sd">           The impact parameter.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        complex :</span>
<span class="sd">            Amplification factor F(f, ml, y, zl).</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">w</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">w_of_f</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="p">,</span> <span class="n">zl</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">Fw_geometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span></div>
</div>

</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Anuj Mishra.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>